/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include"../board/cposition.h"
#include"../movegen/movegenerator.h"
using namespace std;

//-------------------------------------------------------
//
//           unittest check:
//
void test_check()
{
  cout << "Test check() .........................................." << flush;
  bool r=true;
  
  ChessPosition cp;
  
  {
    cp.clear();
    string s="rnbqkbnr/1ppp1ppp/p7/4p3/PP1P4/8/2P1PPPP/RNBQKBNR b KQkq - 0 4";
    cp.fen(s);
    Move m{f8,b4,normal_move,BlackBishop(),WhitePawn()};
    m.check(true);
    cp.make_move(m);
    if(!cp.check()){r=false;}
  }

  {
    cp.clear();
    string s="2k5/4Q3/p1P3p1/8/1P3P1P/8/7K/8 b - - 0 45";
    cp.fen(s);
    cp.make_move(a6,a5);
    if(cp.check()){r=false;}
  }

  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}

}

