/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include"../common/connections.h"
using std::cout;
using std::endl;
using std::flush;



//-------------------------------------------------------
//
//           unittest connections:
//

void test_connections()
{
  cout << "Test Connections ......................................" << flush;
  bool r=true;
  Connections con;

  //------------------------------ file --------------------------------------
  //
  BitBoard a_file=con.file(a4);
  BitBoard b_file=con.file(b7);
  BitBoard c_file=con.file(c1);
  BitBoard d_file=con.file(d2);
  BitBoard e_file=con.file(e3);
  BitBoard f_file=con.file(f5);
  BitBoard g_file=con.file(g6);
  BitBoard h_file=con.file(h8);

  BitBoard whole_board;
  for(int i=0;i<64;i++){whole_board.set_square(i);}
  if(whole_board!=(a_file|b_file|c_file|d_file|e_file|f_file|g_file|h_file)){r=false;}
  if(a_file&b_file&c_file&d_file&e_file&f_file&g_file&h_file){r=false;}



  //------------------------------ rank --------------------------------------
  //
  BitBoard rank_3=con.rank(e3);
  if(!(a3.bitboard() & rank_3)){r=false;}
  if(!(b3.bitboard() & rank_3)){r=false;}
  if(!(c3.bitboard() & rank_3)){r=false;}
  if(!(e3.bitboard() & rank_3)){r=false;}
  if(!(h3.bitboard() & rank_3)){r=false;}

  if(a5.bitboard() & rank_3){r=false;}
  if(e6.bitboard() & rank_3){r=false;}

  BitBoard rank_8=con.rank(h8);
  if(!(a8.bitboard() & rank_8)){r=false;}
  if(!(b8.bitboard() & rank_8)){r=false;}

  if(c7.bitboard() & rank_8){r=false;}
  if(e4.bitboard() & rank_8){r=false;}
  if(h1.bitboard() & rank_8){r=false;}

  //------------------------------ ray --------------------------------------
  //
  BitBoard ray_1=con.ray(e4,f5);
  if(!(g6.bitboard() & ray_1)){r=false;}
  ray_1=con.ray(d4,c5);
  if(!(a7.bitboard() & ray_1)){r=false;}
  if(g1.bitboard() & ray_1){r=false;}
  ray_1=con.ray(d4,c5);
  if(!(a7.bitboard() & ray_1)){r=false;}
  if(g1.bitboard() & ray_1){r=false;}
  ray_1=con.ray(b3,a3);
  if(!(a3.bitboard() & ray_1)){r=false;}
  if(c1.bitboard() & ray_1){r=false;}
  ray_1=con.ray(e4,g2);
  if(!(f3.bitboard() & ray_1)){r=false;}
  if(!(h1.bitboard() & ray_1)){r=false;}
  if(a8.bitboard() & ray_1){r=false;}
  ray_1=con.ray(d3,f3);
  if(!(g3.bitboard() & ray_1)){r=false;}
  if(c3.bitboard() & ray_1){r=false;}
  

  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}

}






