/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include"../search/duration.h"
using namespace std;

//-------------------------------------------------------
//
//           unittest Duration:
//

void test_duration()
{
  cout << "Test Duration ........................................." << flush;
  bool r=true;

  std::chrono::duration<double,ratio<1>> dura{60};
  Duration d{dura};
  if(d.minutes()!=1){r=false;}
  if(d.centiseconds()!=6000){r=false;}
  if(d.milliseconds()!=60000){r=false;}
  if(d.nanoseconds()!=60000000000ull){r=false;}

  d.seconds(5);
  if(d.milliseconds()!=5000){r=false;}
  d.milliseconds(50);
  if(d.centiseconds()!=5){r=false;}
  d.centiseconds(6000);
  if(d.minutes()!=1){r=false;}

  Duration d1,d2;
  d1.minutes(1);
  d2.seconds(80);
  if((d1-d2).seconds() != -20){r=false;}
  
  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}
  
}






