/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include"../board/cposition.h"
#include"../eval/material.h"
using namespace std;

//-------------------------------------------------------
//
//           unittest material:
//

void test_material()
{
  cout << "Test Material ........................................." << flush;
  bool r=true;

  MaterialIndex mi;
  Material m;

  //cout << m.dump() << endl;

  {
    ChessPosition cp;
    string fen="rnbqkbnr/8/8/8/8/8/PPPPPPPP/4K3 w - - 0 1";
    cp.fen(fen);
    mi=cp.materialindex();
    int ev=m.get_eval(mi);
    if(ev!=-2595){cout << "test3: ev=" << ev << endl;r=false;}
  }

  {
    ChessPosition cp;
    string fen="3qk3/8/8/8/8/8/8/4KR2 w - - 0 1";
    cp.fen(fen);
    mi=cp.materialindex();
    int ev=m.get_eval(mi);
    if(ev!=-450){cout << "test4: ev=" << ev << endl;r=false;}
  }

  {
    ChessPosition cp;
    string s="8/1k6/8/8/8/8/6p1/2R3K1 w - - 0 1";
    cp.fen(s);
    mi=cp.materialindex();
    int ev=m.get_eval(mi);
    if(ev>=450){cout << "test5: ev=" << ev << endl;r=false;}
  }

  
  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}

}






