/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include"../board/cposition.h"
#include"../board/rep3filter.h"
using namespace std;

//-------------------------------------------------------
//
//           unittest rep3filter:
//

void test_rep3filter()
{
  cout << "Test Rep3filter ......................................." << flush;
  bool r=true;

  ChessPosition cp;
  
  {
    string s="6k1/PQP2ppp/1P6/8/8/6q1/6P1/7K b - - 0 1";
    cp.fen(s);

    cp.make_move(g3,e1);
    cp.make_move(h1,h2);
    cp.make_move(e1,h4);
    cp.make_move(h2,g1);

    cp.make_move(h4,e1);
    cp.make_move(g1,h2);
    cp.make_move(e1,h4);
    cp.make_move(h2,g1);

    cp.make_move(h4,e1);
    cp.make_move(g1,h2);

    if(!cp.draw_by_threefold_repetition()){r=false;}
  }
  
  {
    string s{"1k6/5RP1/1P6/1K6/6r1/8/8/8 w - - 0 1"};
    cp.fen(s);
    cp.make_move(f7,f8);
    cp.make_move(b8,b7);
    cp.make_move(f8,f7);
    cp.make_move(b7,b8);
    if(!cp.draw_by_threefold_repetition()){r=false;}
  }

  
  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}

}






