/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include<stdexcept>
#include"../common/bitboard.h"
#include"../common/rookmask.h"
using std::cout;
using std::endl;
using std::flush;
using std::logic_error;


//-------------------------------------------------------
//
//           unittest bishopmask:
//

void test_rookmask()
{
  bool r=true;

  {
    RookMask rm;
    BitBoard x;
    x=rm.get_mask(d4);
    if(BitBoard::to_ull(x)!=0x0008080876080800){r=false;}
  }

  {
    RookMask rm;
    BitBoard x;
    x=rm.get_mask(g2);
    if(BitBoard::to_ull(x)!=0x0040404040403e00){r=false;}
  }

  {
    RookMask rm;
    BitBoard x;
    x=rm.get_mask(a1);
    if(BitBoard::to_ull(x)!=0x000101010101017e){r=false;}
  }

  {
    RookMask rm;
    BitBoard x;
    x=rm.get_mask(h8);
    if(BitBoard::to_ull(x)!=0x7e80808080808000){r=false;}
  }




  cout << "Test RookMask ........................................." << flush;
  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}

}






