/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include"../board/cposition.h"
#include"../hashtable/transposition.h"
#include"../search/analyze.h"
using namespace std;

//-------------------------------------------------------
//
//           unittest ThreadPool
//


void test_threadpool()
{
  bool r=true;
  cout << "Test ThreadPool ......................................." << flush;


  ChessPosition cp;
  TranspositionTable tt;
  ThreadPool tp(2,tt);

  if(tp.size()!=2){r=false;}
  /*
  for(int i=0;i<tp.size();i++){
    int n;
    if(!tp.open_new_thread(n)){
      r=false;
    }
  }
  */
  tp.set_size(4);
  if(tp.size()!=4){r=false;}
  /*
  for(int i=0;i<4;i++){
    int n;
    if(!tp.open_new_thread(n) || i!=n){
      r=false;
    }
  }
  */

  /*
  {
    //----------------------------- one thread: --------------------------------------------------------
    std::cerr << boolalpha;
    std::cerr << "\nOne thread: " << endl;
    std::cerr << "---------- " << endl;
    tp.set_size(1);
    Analysis ana(cp,tt,tp);
    ana.set_max_nodes(3000000);
    int n1{0},value{-30000},nodes{0};

    cp.newgame();
    cp.make_move(e2,e4);
    cp.make_move(e7,e5);
    ana.init(cp);
    tp.open_new_thread(n1);
    tp.nw_search(n1,18,0,1,0,0,0,ana);
    tp.result(n1,value,nodes);
    std::cerr << endl << tp.state() << endl;
  }

  {
    //----------------------------- two threads: --------------------------------------------------------
    std::cerr << boolalpha;
    std::cerr << "\nTwo threads: " << endl;
    std::cerr << "-----------" << endl;
    tp.set_size(2);  
    Analysis ana(cp,tt,tp);
    ana.set_max_nodes(3000000);
    int n1{0},n2{-1},value{-30000},nodes{0};

    cp.newgame();
    cp.make_move(e2,e4);
    cp.make_move(e7,e5);
    ana.init(cp);
    tp.open_new_thread(n1);
    tp.nw_search(n1,18,0,1,0,0,0,ana);

    cp.newgame();
    cp.make_move(d2,d4);
    cp.make_move(d7,d5);
    ana.init(cp);
    tp.open_new_thread(n2);
    tp.nw_search(n2,18,0,1,0,0,0,ana);
    tp.result(n1,value,nodes);
    tp.result(n2,value,nodes);
    std::cerr << endl << tp.state() << endl;
  }

  {
    //----------------------------- four threads (two running): ----------------------------------------------------------
    std::cerr << "\nFour threads (two running): " << endl;
    std::cerr << "----------------------------  " << endl;
    tp.set_size(4);
    Analysis ana(cp,tt,tp);
    ana.set_max_nodes(3000000);
    ana.hashtable_enabled(false);
    int n1{0},n2{-1},value{-30000},nodes{0};

    cp.newgame();
    cp.make_move(e2,e4);
    cp.make_move(e7,e5);
    ana.init(cp);
    tp.open_new_thread(n1);
    tp.nw_search(n1,18,0,1,0,0,0,ana);

    cp.newgame();
    cp.make_move(d2,d4);
    cp.make_move(d7,d5);
    ana.init(cp);
    tp.open_new_thread(n2);
    tp.nw_search(n2,18,0,1,0,0,0,ana);
    tp.result(n1,value,nodes);
    tp.result(n2,value,nodes);
    std::cerr << endl << tp.state() << endl;
  }

  {
    //----------------------------- tree cores: ---------------------------------------------------------
    std::cerr << "\nThree threads: " << endl;
    std::cerr << "-------------  " << endl;
    tp.set_size(3);
    Analysis ana(cp,tt,tp);
    ana.set_max_nodes(3000000);
    int n1{0},n2{-1},n3{-1},value{-30000},nodes{0};

    cp.make_move(e2,e4);
    cp.make_move(e7,e5);
    ana.init(cp);
    tp.open_new_thread(n1);
    tp.nw_search(n1,18,0,1,0,0,0,ana);

    cp.newgame();
    cp.make_move(d2,d4);
    cp.make_move(d7,d5);
    ana.init(cp);
    tp.open_new_thread(n2);
    tp.nw_search(n2,18,0,1,0,0,0,ana);

    cp.newgame();
    cp.make_move(d2,d4);
    cp.make_move(f7,f5);
    cp.make_move(c2,c4);
    cp.make_move(e7,e6);
    ana.init(cp);
    tp.open_new_thread(n3);
    tp.nw_search(n3,18,0,1,0,0,0,ana);

    tp.result(n1,value,nodes);
    tp.result(n2,value,nodes);
    tp.result(n3,value,nodes);
    std::cerr << endl << tp.state() << endl;
  }
  */  

  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}

}






