/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include"../hashtable/ttrecord.h"
using namespace std;

//-------------------------------------------------------
//
//           unittest TTrecord:
//

void test_ttrecord()
{
  cout << "Test TTrecord ........................................." << flush;
  bool r=true;

  {
    TTrecord A;
    unsigned long long k=12434545656767878321ull;
    A.set_key(k);

    if(A.get_key()!=12434545656767878321ull){r=false;cout << "error(1)" << endl;}

    A.set_score(4091,5);
    if(A.get_score(5)!=4091){r=false;cout << "error(2)" << endl;}
    A.set_score(-4091,5);
    if(A.get_score(0)!=-4091){r=false;cout << "error(3)" << endl;}

    A.set_score(-mate_value,5);
    if(A.get_score(5)!=-mate_value){r=false;cout << "error mate value(1)" << endl;}
    A.set_score(mate_value-20,5);
    if(A.get_score(0)!=mate_value-15){r=false;cout << "error mate value(2)" << endl;}


    A.set_bound(exact_value);

    if(!A.is_exact_value()){r=false;cout << "error(4)" << endl;}
    if(A.is_upperbound()){r=false;cout << "error(5)" << endl;}
    if(A.is_lowerbound()){r=false;cout << "error(6)" << endl;}


    A.set_bound(upperbound);
    if(A.is_exact_value()){r=false;cout << "error(7)" << endl;}
    if(!A.is_upperbound()){r=false;cout << "error(8)" << endl;}
    if(A.is_lowerbound()){r=false;cout << "error(9)" << endl;}


    A.set_bound(lowerbound);
    if(A.is_exact_value()){r=false;cout << "error(10)" << endl;}
    if(A.is_upperbound()){r=false;cout << "error(11)" << endl;}
    if(!A.is_lowerbound()){r=false;cout << "error(12)" << endl;}


    {
      A.set_draft(21);
      if(A.get_draft()!=21){r=false;cout << "error(20)" << endl;}
      A.set_draft(12);
      if(A.get_draft()!=12){r=false;cout << "error(21)" << endl;}
      A.set_date(67);
      if(A.get_draft()!=12){r=false;cout << "error(22)" << endl;}
      if(A.get_date()!=67){r=false;cout << "error(23)" << endl;}
      A.set_draft(21);
      if(A.get_draft()!=21){r=false;cout << "error(24)" << endl;}
      if(A.get_date()!=67){r=false;cout << "error(25)" << endl;}
    }
    

  }




  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}

}






