/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include"../board/cposition.h"
#include"../movegen/movegenerator.h"
using namespace std;

//-------------------------------------------------------
//
//           unittest ChessPosition:
//
void test_unmake()
{
  bool r=true;

  cout << "Test unmake ..........................................." << flush;

  ChessPosition cp;
  cp.newgame();
  string s="rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1";
  if(cp.fen()!=s){r=false;}
  cp.make_move(e2,e4);
  string s1="rnbqkbnr/pppppppp/8/8/4P3/8/PPPP1PPP/RNBQKBNR b KQkq - 0 1";
  cp.make_move(e7,e5);
  cp.unmake_move();
  if(cp.fen()!=s1){r=false;}
  cp.unmake_move();
  if(cp.fen()!=s){r=false;}

  cp.make_move(e2,e4);
  cp.make_move(a7,a6);
  cp.make_move(e4,e5);
  cp.make_move(d7,d5);
  s1="rnbqkbnr/1pp1pppp/p7/3pP3/8/8/PPPP1PPP/RNBQKBNR w KQkq d6 0 3";
  cp.make_move(e5,d6);
  cp.unmake_move();
  if(s1!=cp.fen()){r=false;}

  cp.newgame();
  cp.make_move(a2,a3);
  cp.make_move(e7,e5);
  cp.make_move(a3,a4);
  cp.make_move(e5,e4);
  cp.make_move(d2,d4);
  s1=cp.fen();
  cp.make_move(e4,d3);
  cp.unmake_move();
  if(s1!=cp.fen()){r=false;}


  cp.newgame();
  cp.make_move(a2,a4);
  cp.make_move(a7,a5);
  cp.make_move(h2,h4);
  cp.make_move(h7,h5);
  s1=cp.fen();
  cp.make_move(a1,a2);
  cp.make_move(a8,a7);
  cp.make_move(h1,h2);
  cp.make_move(h8,h7);
  cp.unmake_move();
  cp.unmake_move();
  cp.unmake_move();
  cp.unmake_move();
  if(s1!=cp.fen()){r=false;}

  cp.newgame();
  cp.make_move(g1,f3);
  cp.make_move(g8,f6);
  cp.make_move(g2,g3);
  cp.make_move(g7,g6);
  cp.make_move(f1,g2);
  cp.make_move(f8,g7);
  s1=cp.fen();
  cp.make_move(e1,g1);
  cp.make_move(e8,g8);
  cp.unmake_move();
  cp.unmake_move();
  if(s1!=cp.fen()){r=false;}
  /*
  Piece white_king,black_king,white_pawn,black_rook;
  white_king.set_white_king();black_king.set_black_king();
  white_pawn.set_white_pawn();black_rook.set_black_rook();
  cp.clear();
  cp.set_piece_on(h1,white_king);
  cp.set_piece_on(e7,white_pawn);
  cp.set_piece_on(h8,black_king);
  cp.set_piece_on(d8,black_rook);
  s1=cp.fen();
  Move m;
  m.from(e7);
  m.to(d8);
  m.code(promo_queen);
  m.piece(WhitePawn());
  m.capture(BlackRook());
  cp.make_move(m);
  cp.unmake_move();
  if(s1!=cp.fen()){r=false;}
  */
  
  cp.newgame();
  cp.make_move(g1,f3);
  cp.make_move(g8,f6);
  s1=cp.fen();
  cp.make_move(d2,d4);
  cp.unmake_move();
  if(s1!=cp.fen()){r=false;}


  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}

}

