/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef HASHER_H
#define HASHER_H

class ChessPosition;

class Hasher
{
 private:
  const ChessPosition* cp;
  uint64_t m_piece_square[15*64];
  uint64_t m_pawn_square[15*64];
  uint64_t m_castle_K;
  uint64_t m_castle_Q;
  uint64_t m_castle_k;
  uint64_t m_castle_q;
  uint64_t m_en_passant[8];
  uint64_t m_turn;
  uint64_t castle()const;
  vector<uint64_t> m_hash;
  vector<uint64_t> m_pawnhash;

 public:
  Hasher();
  void init(const ChessPosition*);
  void init(const ChessPosition&);
  void make_move(const Move&);
  void unmake_move(const Move&);
  uint64_t hash()const;
  uint64_t pawnhash()const;
};



#endif
