/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"distance.h"


auto distance_between_squares=[](Square x,Square y)->int
{
  int xfile=x.file_number(),yfile=y.file_number();
  int xrank=x.rank_number(),yrank=y.rank_number();
  int file_distance=xfile<yfile?yfile-xfile:xfile-yfile;
  int rank_distance=xrank<yrank?yrank-xrank:xrank-yrank;
  int r=file_distance>rank_distance?file_distance:rank_distance;
  return r;
};


Distance::Distance()
{
  for(Square s1=a1;s1<=h8;s1++){
    for(Square s2=a1;s2<=h8;s2++){
      m_d_square_square[s1.id()][s2.id()]=distance_between_squares(s1,s2);
    }
  }

  for(Square s1=a1;s1<=h8;s1++){
    m_d_square_bitboard[s1.id()][0]=s1.bitboard();

    BitBoard bb=s1.bitboard() | s1.bitboard()<<8 | s1.bitboard()>>8;
    bb|= bb<<1 & ~a_file;
    bb|= bb>>1 & ~h_file;
    m_d_square_bitboard[s1.id()][1]=bb;
    
    bb|= bb<<8 | bb>>8;
    bb|= bb<<1 & ~a_file;
    bb|= bb>>1 & ~h_file;
    m_d_square_bitboard[s1.id()][2]=bb;
    
    bb|= bb<<8 | bb>>8;
    bb|= bb<<1 & ~a_file;
    bb|= bb>>1 & ~h_file;
    m_d_square_bitboard[s1.id()][3]=bb;
    
    bb|= bb<<8 | bb>>8;
    bb|= bb<<1 & ~a_file;
    bb|= bb>>1 & ~h_file;
    m_d_square_bitboard[s1.id()][4]=bb;
    
    bb|= bb<<8 | bb>>8;
    bb|= bb<<1 & ~a_file;
    bb|= bb>>1 & ~h_file;
    m_d_square_bitboard[s1.id()][5]=bb;
    
    bb|= bb<<8 | bb>>8;
    bb|= bb<<1 & ~a_file;
    bb|= bb>>1 & ~h_file;
    m_d_square_bitboard[s1.id()][6]=bb;
    
    bb|= bb<<8 | bb>>8;
    bb|= bb<<1 & ~a_file;
    bb|= bb>>1 & ~h_file;
    m_d_square_bitboard[s1.id()][7]=bb;
    
  }  
}

const int Distance::operator()(const Square& s1,const Square& s2)const
{
  return m_d_square_square[s1.id()][s2.id()];  
}

const int Distance::operator()(const Square& s1,const BitBoard& s2)const
{
  return 8-
    (
    static_cast<bool>(m_d_square_bitboard[s1.id()][0] & s2)
    + static_cast<bool>(m_d_square_bitboard[s1.id()][1] & s2)
    + static_cast<bool>(m_d_square_bitboard[s1.id()][2] & s2)
    + static_cast<bool>(m_d_square_bitboard[s1.id()][3] & s2)
    + static_cast<bool>(m_d_square_bitboard[s1.id()][4] & s2)
    + static_cast<bool>(m_d_square_bitboard[s1.id()][5] & s2)
    + static_cast<bool>(m_d_square_bitboard[s1.id()][6] & s2)
    + static_cast<bool>(m_d_square_bitboard[s1.id()][7] & s2)
     );
}


