/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef MOVELIST_H
#define MOVELIST_H


#include"xmovelist.h"



class MoveList
{
 private:
  XMoveList& m_xml;

 public:
  MoveList(XMoveList&);
  ~MoveList();
  bool operator==(const MoveList&)const;
  Move& operator[](int);
  void set_chessposition(ChessPosition&);
  void set_analysis(Analysis*);
  void set_searchmoves(const vector<Move>&);
  void set_hashtable_move(const Move&);
  void set_killers(const Move&,const Move&);
  void set_killers_2(const Move&,const Move&);
  void set_log(bool);
  void set_xcodes();
  void sort();
  void add(const Move&);
  void remove(const Move&);
  void clear();
  const Move& first();
  const Move& next();
  Move& back();
  void insert(vector<Move>::iterator,vector<Move>::iterator);
  void pop_back();
  void push_back(const Move&);
  unsigned int size()const;
  string dump()const;
};



#endif
