/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"lmr.h"


LmrTable::LmrTable()
{
  for(int mi=0;mi<256;mi++){m_lmr[0][mi]=m_lmr[1][mi]=m_lmr[2][mi]=m_lmr[3][mi]=0;}
  for(int depth=4;depth<max_search_depth;depth++){
    for(int mi=0;mi<256;mi++){
      if(mi<1){
	m_lmr[depth][mi]=0;
      }else{
	m_lmr[depth][mi]=sqrt(depth)-1 + mi/8;
      }
    }
  }
}

const char& LmrTable::value(const int& depth, const unsigned int& move)const
{
  return m_lmr[depth][move];
}

