/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef TIMEMANAGER_H
#define TIMEMANAGER_H

#include"timer.h"


class TimeManager
{
 private:
  int m_wtime,m_btime,m_winc,m_binc,m_movestogo,m_mate;
  long long m_nodes,m_movetime;
  bool m_infinite,m_pondering,m_white_to_move;
  Timer m_tim;
  
 public:
  TimeManager();
  void reset();
  void start();
  bool time_to_move(long long);
  int remaining_time();

  void set_wtime(int);
  void set_btime(int);
  void set_winc(int);
  void set_binc(int);
  void set_movestogo(int);
  void set_nodes(long long);
  void set_mate(int);
  void set_movetime(long long);
  void set_infinite(bool);
  void set_pondering(bool);
  void set_white_to_move(bool);
};


#endif
