/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"anaw.h"


AnalysisWindow::AnalysisWindow()
{
  set_title("Galjoen: analysis");
  set_border_width(5);
  set_default_size(600, 200);
  add(m_ScrolledWindow);
  
  m_TextView.set_editable(false);
  m_TextView.set_cursor_visible(false);
  m_ScrolledWindow.add(m_TextView);
  m_ScrolledWindow.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC);

  m_TextBuffer = Gtk::TextBuffer::create();
  m_TextBuffer->set_text("");
  m_TextView.set_buffer(m_TextBuffer);

  show_all_children();
};

AnalysisWindow::~AnalysisWindow()
{
};

void AnalysisWindow::add_text(string x)
{
  Glib::ustring ux=x;
  m_TextBuffer->insert(m_TextBuffer->end(),ux);
  auto iter=m_TextBuffer->end();
  m_TextView.scroll_to(iter);
  m_TextView.set_buffer(m_TextBuffer);
}

void AnalysisWindow::clear()
{
  Glib::ustring ux="";
  m_TextBuffer->set_text(ux);
  m_TextView.set_buffer(m_TextBuffer);
}
