/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef CLOCK_H
#define CLOCK_H


#include<string>
#include"../engine/search/timer.h"
#include"level.h"
using std::string;
using std::milli;
using dura=duration<double,milli>;


class Clock
{
 public:
  void reset();
  Duration get_time();
  void set_time(Duration);
  void set_movestogo(int);
  void start_clock();
  void move_and_stop_clock();
  void stop_clock();
  Level level();
  string get_level();
  void set_level(int,string,int);
  void set_level(Level);
  void set_moves(int);
  int get_moves();
  int get_movestogo()const;
  Duration get_inc()const;

 private:
  Timer tim;
  Duration m_time;  

  //----- level: --------------------
  int m_mps;
  Duration m_base;
  Duration m_inc;
  int m_moves;
  //---------------------------------
};



#endif
