/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"option.h"
#include<sstream>
#include<iostream>
using std::endl;
using std::istringstream;



Option::Option(string x)
{
  while(x[x.size()-1]=='\n' || x[x.size()-1]==' '){x.pop_back();}
  string s;
  vector<string> token;
  unsigned int i{0};
  while(i<x.size()){
    if(x[i]=='o' && x[i+1]=='p' && x[i+2]=='t' && x[i+3]=='i' && x[i+4]=='o' && x[i+5]=='n'){
      i+=6;
      while(i<x.size() && x[i]==' '){i++;}
    }
    if(x[i]=='n' && x[i+1]=='a' && x[i+2]=='m' && x[i+3]=='e'){
      i+=4;
      while(i<x.size() && x[i]==' '){i++;}
      while(s[s.size()-1]==' '){s.pop_back();}
      token.push_back(s);
      s="";
      token.push_back("name");
    }
    //------- xboard:
    if(x[i]=='-' && x[i+1]=='b' && x[i+2]=='u' && x[i+3]=='t' && x[i+4]=='t' && x[i+5]=='o' && x[i+6]=='n'){
      i+=7;
      while(i<x.size() && x[i]==' '){i++;}
      while(s[s.size()-1]==' '){s.pop_back();}
      token.push_back(s);
      s="";
      token.push_back("type");
      token.push_back("button");
    }
    if(x[i]=='-' && x[i+1]=='c' && x[i+2]=='h' && x[i+3]=='e' && x[i+4]=='c' && x[i+5]=='k'){
      i+=6;
      string values=x.substr(i);
      istringstream iss(values);
      while(i<x.size() && x[i]==' '){i++;}
      while(s[s.size()-1]==' '){s.pop_back();}
      token.push_back(s);
      s="";
      token.push_back("type");
      token.push_back("check");
      token.push_back("default");
      string value;
      iss >> value;
      if(value=="0"){value="false";}else{value="true";}
      token.push_back(value);
      break;
    }
    if(x[i]=='-' && x[i+1]=='s' && x[i+2]=='p' && x[i+3]=='i' && x[i+4]=='n'){
      i+=5;
      string values=x.substr(i);
      istringstream iss(values);
      while(i<x.size() && x[i]==' '){i++;}
      while(s[s.size()-1]==' '){s.pop_back();}
      token.push_back(s);
      s="";
      string value,smin,smax;
      iss >> value >> smin >> smax;
      token.push_back("type");
      token.push_back("spin");
      token.push_back("default");
      token.push_back(value);
      token.push_back("min");
      token.push_back(smin);
      token.push_back("max");
      token.push_back(smax);
      break;
    }
    if(x[i]=='-' && x[i+1]=='c' && x[i+2]=='o' && x[i+3]=='m' && x[i+4]=='b' && x[i+5]=='o'){
      i+=6;
      string values=x.substr(i);
      istringstream iss(values);
      while(i<x.size() && x[i]==' '){i++;}
      while(s[s.size()-1]==' '){s.pop_back();}
      token.push_back(s);
      s="";
      string value,separator;
      token.push_back("type");
      token.push_back("combo");
      token.push_back("var");
      while(!iss.eof()){
	iss >> value;
	token.push_back(value);
	separator="";
	iss >> separator;
	if(separator==R"(///)"){
	  token.push_back("var");
	}
	else{break;}
      }
      break;
    }
    if(x[i]=='-' && x[i+1]=='s' && x[i+2]=='t' && x[i+3]=='r' && x[i+4]=='i' && x[i+5]=='n' && x[i+6]=='g'){
      i+=7;
      while(i<x.size() && x[i]==' '){i++;}
      while(s[s.size()-1]==' '){s.pop_back();}
      token.push_back(s);
      s="";
      token.push_back("type");
      token.push_back("string");
      token.push_back("default");
      string value=x.substr(i);
      while(value[value.size()-1]==' '){value.pop_back();}
      token.push_back(value);
      break;
    }
    //---------------
    if(x[i]=='t' && x[i+1]=='y' && x[i+2]=='p' && x[i+3]=='e'){
      i+=4;
      while(i<x.size() && x[i]==' '){i++;}
      while(s[s.size()-1]==' '){s.pop_back();}
      token.push_back(s);
      s="";
      token.push_back("type");
    }
    if(x[i]=='d' && x[i+1]=='e' && x[i+2]=='f' && x[i+3]=='a' && x[i+4]=='u' && x[i+5]=='l' && x[i+6]=='t'){
      i+=7;
      while(i<x.size() && x[i]==' '){i++;}
      while(s[s.size()-1]==' '){s.pop_back();}
      token.push_back(s);
      s="";
      token.push_back("default");
    }
    if(x[i]=='m' && x[i+1]=='i' && x[i+2]=='n'){
      i+=3;
      while(i<x.size() && x[i]==' '){i++;}
      while(s[s.size()-1]==' '){s.pop_back();}
      token.push_back(s);
      s="";
      token.push_back("min");
    }
    if(x[i]=='m' && x[i+1]=='a' && x[i+2]=='x'){
      i+=3;
      while(i<x.size() && x[i]==' '){i++;}
      while(s[s.size()-1]==' '){s.pop_back();}
      token.push_back(s);
      s="";
      token.push_back("max");
    }
    if(x[i]=='v' && x[i+1]=='a' && x[i+2]=='r'){
      i+=3;
      while(i<x.size() && x[i]==' '){i++;}
      while(s[s.size()-1]==' '){s.pop_back();}
      token.push_back(s);
      s="";
      token.push_back("var");
    }

    s+=x[i++];
  }

  while(!s.empty() && s[s.size()-1]==' '){s.pop_back();}
  token.push_back(s);

  for(size_t i=0;i<token.size();i++){
    if(token[i]=="name"){set_name(token[i+1]);}
    if(token[i]=="type"){set_type(token[i+1]);}
    if(token[i]=="default"){set_default(token[i+1]);}
    if(token[i]=="min"){set_min(token[i+1]);}
    if(token[i]=="max"){set_max(token[i+1]);}
    if(token[i]=="var"){add_var(token[i+1]);}
  }
  m_value=m_default;
  m_changed=false;
}

string Option::name()const
{
  return m_name;
}

string Option::type()const
{
  return m_type;
}

string Option::default_value()const
{
  return m_default;
}

string Option::minimum_value()const
{
  return m_min;
}

string Option::maximum_value()const
{
  return m_max;
}

vector<string> Option::var()const
{
  return m_var;
}

string Option::value()const
{
  return m_value;
}

bool Option::changed()const
{
  return m_changed;
}

void Option::set_name(string x)
{
  m_name=x;
}

void Option::set_type(string x)
{
  m_type=x;
}

void Option::set_default(string x)
{
  m_default=x;
}

void Option::set_min(string x)
{
  m_min=x;
}

void Option::set_max(string x)
{
  m_max=x;
}

void Option::add_var(string x)
{
  m_var.push_back(x);
}

void Option::set_value(string x)
{
  m_value=x;
}

void Option::set_changed(bool x)
{
  m_changed=x;
}
