/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef OPTION_H
#define OPTION_H

#include<vector>
#include<string>
using std::string;
using std::vector;



class Option
{
 private:
  string m_name;
  string m_type;
  string m_default;
  string m_min;
  string m_max;
  vector<string> m_var;
  string m_value;
  bool m_changed;
  
 public:
  Option()=default;
  Option(string);
  string name()const;
  string type()const;
  string default_value()const;
  string minimum_value()const;
  string maximum_value()const;
  vector<string> var()const;
  string value()const;
  bool changed()const;

  void set_name(string);
  void set_type(string);
  void set_default(string);
  void set_min(string);
  void set_max(string);
  void add_var(string);
  void set_value(string);
  void set_changed(bool);
};



#endif
