/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef PGNFILE_H
#define PGNFILE_H

#include<fstream>
#include<vector>
#include<string>
#include<utility>
using std::string;
using std::ifstream;
using std::ofstream;
using std::vector;
using std::pair;


class PgnFile
{
 private:
  ifstream ifs;
  ofstream ofs;
  bool m_good{false};
  void remove_carriage_return(string& x)const;
 
 public:
  void open_input(string);
  void open_output(string);
  void close_input();
  void close_output();
  string get_first_game();
  string get_next_game();
  vector<pair<string,string>> get_first_tags();
  vector<pair<string,string>> get_next_tags();
  void add_game(string);
  bool good()const;
};


#endif
