/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"piecechoicedraw.h"
#include<cairomm/context.h>
#include<gdkmm/general.h> // set_source_pixbuf()
#include<glibmm/fileutils.h>
#include<iostream>
using std::cout;
using std::endl;


PieceChoiceDraw::PieceChoiceDraw(const PieceChoiceDraw& x)
{
  set_size_request(180,240);
  m_image=x.m_image;
}

PieceChoiceDraw::PieceChoiceDraw(const vector<Glib::RefPtr<Gdk::Pixbuf>>& x) : m_image(x)
{
  set_size_request(180,240);
}

PieceChoiceDraw::~PieceChoiceDraw()
{
}

bool PieceChoiceDraw::on_draw(const Cairo::RefPtr<Cairo::Context>& cr)
{
  Gtk::Allocation allocation = get_allocation();
  const int width = allocation.get_width();
  const int height = allocation.get_height();
  int h_delta=width/3;
  int v_delta=height/4;

  //---------------------------- white pieces: --------------------
  cr->rectangle(0,0,h_delta,v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_image[1],0,0);
  cr->fill();
  
  cr->rectangle(h_delta,0,2*h_delta,v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_image[2],h_delta,0);
  cr->fill();
  
  cr->rectangle(2*h_delta,0,3*h_delta,v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_image[3],2*h_delta,0);
  cr->fill();
  
  cr->rectangle(0,v_delta,h_delta,2*v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_image[4],0,v_delta);
  cr->fill();
  
  cr->rectangle(h_delta,v_delta,2*h_delta,2*v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_image[5],h_delta,v_delta);
  cr->fill();
  
  cr->rectangle(2*h_delta,v_delta,3*h_delta,2*v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_image[6],2*h_delta,v_delta);
  cr->fill();

  
  //---------------------------- black pieces: --------------------
  cr->rectangle(0,2*v_delta,h_delta,3*v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_image[8],0,2*v_delta);
  cr->fill();
  
  cr->rectangle(h_delta,2*v_delta,2*h_delta,3*v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_image[9],h_delta,2*v_delta);
  cr->fill();
  
  cr->rectangle(2*h_delta,2*v_delta,3*h_delta,3*v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_image[10],2*h_delta,2*v_delta);
  cr->fill();

  cr->rectangle(0,3*v_delta,h_delta,4*v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_image[11],0,3*v_delta);
  cr->fill();
  
  cr->rectangle(h_delta,3*v_delta,2*h_delta,4*v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_image[12],h_delta,3*v_delta);
  cr->fill();
  
  cr->rectangle(2*h_delta,3*v_delta,3*h_delta,4*v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_image[13],2*h_delta,3*v_delta);
  cr->fill();



  
  cr->paint();
  return true;

}
