/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"piecechoiceevent.h"
#include<iostream>
using std::cout;
using std::endl;


PieceChoiceEvent::PieceChoiceEvent(const PieceChoiceEvent& x): m_drawing{x.m_drawing}
{
  m_choice=x.m_choice;
  m_drawing.show();
  add(m_drawing);
  set_events(Gdk::BUTTON_PRESS_MASK);
  signal_button_press_event().connect(sigc::mem_fun(*this,
						    &PieceChoiceEvent::on_eventbox_button_press));
  show();
}

PieceChoiceEvent::PieceChoiceEvent(const vector<Glib::RefPtr<Gdk::Pixbuf>>& x) : m_drawing(x)
{
  m_drawing.show();
  add(m_drawing);
  set_events(Gdk::BUTTON_PRESS_MASK);
  signal_button_press_event().connect(sigc::mem_fun(*this,&PieceChoiceEvent::on_eventbox_button_press));
  show();
}


PieceChoiceEvent::~PieceChoiceEvent()
{
}

bool PieceChoiceEvent::on_eventbox_button_press(GdkEventButton* E)
{
  int x,y,width,height;
  get_pointer(x,y);
  width=get_allocated_width()/3;
  height=get_allocated_height()/4;
  x/=width;
  y/=height;

  if(x==0 && y==0){m_choice=1;}
  if(x==1 && y==0){m_choice=2;}
  if(x==2 && y==0){m_choice=3;}
  if(x==0 && y==1){m_choice=4;}
  if(x==1 && y==1){m_choice=5;}
  if(x==2 && y==1){m_choice=6;}
  if(x==0 && y==2){m_choice=8;}
  if(x==1 && y==2){m_choice=9;}
  if(x==2 && y==2){m_choice=10;}
  if(x==0 && y==3){m_choice=11;}
  if(x==1 && y==3){m_choice=12;}
  if(x==2 && y==3){m_choice=13;}
  signal_choice_made.emit();
  return true;
}

int PieceChoiceEvent::get_choice()const
{
  return m_choice;
}
