/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef GTKMM_PIECECHOICEEVENT_H
#define GTKMM_PIECECHOICEEVENT_H


#include"piecechoicedraw.h"
#include<gtkmm/eventbox.h>


class PieceChoiceEvent : public Gtk::EventBox
{
 public:
  PieceChoiceEvent(const PieceChoiceEvent&);
  PieceChoiceEvent(const vector<Glib::RefPtr<Gdk::Pixbuf>>&);
  virtual ~PieceChoiceEvent();
  sigc::signal<bool> signal_choice_made;

  int get_choice()const;

 protected:
  virtual bool on_eventbox_button_press(GdkEventButton*);
 
 private:
  PieceChoiceDraw m_drawing;
  int m_choice;
};



#endif // GTKMM_PIECECHOICEEVENT_H

