/*

Copyright (C) 2018 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"promochoiceevent.h"
#include<iostream>
using std::cout;
using std::endl;


PromoChoiceEvent::PromoChoiceEvent(const PromoChoiceEvent& x): drawing{x.drawing}
{
  m_choice=x.m_choice;
  drawing.show();
  add(drawing);
  set_events(Gdk::BUTTON_PRESS_MASK);
  signal_button_press_event().connect(sigc::mem_fun(*this,
						    &PromoChoiceEvent::on_eventbox_button_press));
  show();
}

PromoChoiceEvent::PromoChoiceEvent(const Glib::RefPtr<Gdk::Pixbuf>& queen,
				   const Glib::RefPtr<Gdk::Pixbuf>& rook,
				   const Glib::RefPtr<Gdk::Pixbuf>& bishop,
				   const Glib::RefPtr<Gdk::Pixbuf>& knight) :
  drawing{PromoChoiceDraw(queen,rook,bishop,knight)}
{
  drawing.show();
  add(drawing);
  set_events(Gdk::BUTTON_PRESS_MASK);
  signal_button_press_event().connect(sigc::mem_fun(*this,
						    &PromoChoiceEvent::on_eventbox_button_press));
  show();
}


PromoChoiceEvent::~PromoChoiceEvent()
{
}

bool PromoChoiceEvent::on_eventbox_button_press(GdkEventButton* E)
{
  int x,y,width,height;
  get_pointer(x,y);
  width=get_allocated_width()/2;
  height=get_allocated_height()/2;
  x/=width;
  y/=height;

  if(x==0 && y==0){m_choice=4;}
  if(x==1 && y==0){m_choice=5;}
  if(x==0 && y==1){m_choice=6;}
  if(x==1 && y==1){m_choice=7;}
  signal_choice_made.emit();
  return true;
}

int PromoChoiceEvent::get_choice()const
{
  return m_choice;
}
